package BankApp;

//import java.net.Socket;
//import java.net.ServerSocket;
//import java.lang.Object;
//import java.io.DataInputStream;
//import java.io.RandomAccessFile;
import java.io.*;
import java.net.*;


//import java.nio.*;
//import java.util.*;


public class PacketWrapper
{
	protected static byte[] buffer=new byte[BankUtility.OpIDLength];
	//protected ServerSocket socket;
	//protected RandomAccessFile file;

	public static Packet readPacket(Socket socket)
	{
		Packet packet=new Packet();
		try
		{
			
			
			//java.io.DataInputStream  inStream=new java.io.DataInputStream(socket.getInputStream());	
			DataInputStream  inStream=new DataInputStream(socket.getInputStream());	
			
			inStream.readFully(buffer, 0, BankUtility.OpIDLength);
			//inStream.readFully(buffer);
			packet.opID= new String(buffer,0,BankUtility.OpIDLength);
			packet.seqNumber=inStream.readLong();
			packet.opType=inStream.readInt();
			packet.source=inStream.readInt();
			packet.dest=inStream.readInt();
			packet.oldValue=inStream.readFloat();
			packet.newValue=inStream.readFloat();
			packet.destOldValue=inStream.readFloat();
			packet.destNewValue=inStream.readFloat();
			packet.tag=inStream.readInt();
			packet.status=inStream.readInt();
		}
		catch(Exception er)
		{
			System.out.println(er.getMessage());
		}
		return packet;
	}

	public static void writePacket(Socket socket, Packet packet)
	{
		try
		{
			java.io.DataOutputStream  outStream=new java.io.DataOutputStream(socket.getOutputStream());	
			outStream.writeBytes(packet.opID);
			outStream.writeLong(packet.seqNumber);
			outStream.writeInt(packet.opType);
			outStream.writeInt(packet.source);
			outStream.writeInt(packet.dest);
			outStream.writeFloat(packet.oldValue);
			outStream.writeFloat(packet.newValue);
			outStream.writeFloat(packet.destOldValue);
			outStream.writeFloat(packet.destNewValue);
			outStream.writeInt(packet.tag);
			outStream.writeInt(packet.status);
		}
		catch (Exception er)
		{
			System.out.println(er.getMessage());
		}
	}

	public static Packet readPacket(RandomAccessFile file)
	{
		Packet packet=new Packet();
		try
		{
			file.readFully(buffer, 0, BankUtility.OpIDLength);
			//file.readFully(buffer);
			packet.opID= new String(buffer,0,BankUtility.OpIDLength);
			packet.seqNumber=file.readLong();
			packet.opType=file.readInt();
			packet.source=file.readInt();
			packet.dest=file.readInt();
			packet.oldValue=file.readFloat();
			packet.newValue=file.readFloat();
			packet.destOldValue=file.readFloat();
			packet.destNewValue=file.readFloat();
			packet.tag=file.readInt();
			packet.status=file.readInt();
		}
		catch (Exception er)
		{
			// System.out.println(er.getMessage());
		}
		return packet;
	}

	public static void writePacket(RandomAccessFile file, Packet packet)
	{
		try
		{
			file.writeBytes(packet.opID);
			file.writeLong(packet.seqNumber);
			file.writeInt(packet.opType);
			file.writeInt(packet.source);
			file.writeInt(packet.dest);
			file.writeFloat(packet.oldValue);
			file.writeFloat(packet.newValue);
			file.writeFloat(packet.destOldValue);
			file.writeFloat(packet.destNewValue);
			file.writeInt(packet.tag);
			file.writeInt(packet.status);
		}
		catch (Exception er)
		{
			System.out.println(er.getMessage());
		}

	}		
}