package BankServer;

import java.net.*;
import java.io.*;
import BankApp.*;
import BankApp.Packet;
import BankApp.BankUtility.*;





public class UDPDialogServer
{
	protected UDPClientSocket client=new UDPClientSocket();
	protected UDPServerSocket server;	
	
	
	public UDPDialogServer(int portNumber)
	{
		server=new UDPServerSocket(portNumber);
	}


	public synchronized Packet recvPacket() 
	{
		return server.recvPacket();
	}


	//use the previous reply portnumber
	public synchronized void replyPacket(Packet packet) throws Exception
	{
		packet.status=BankUtility.REPLY;
		client.sendPacket(server.replyHostName, server.replyPortNumber, packet);		
	}
		

} //end class







